// ------------------------------------
// Version 1.0 : Base de données NoSQL
// ------------------------------------

// Copyright (C) 2014 (Aridhi, Lacomme, Phan)

// Ce programme (ainsi que la bibliothèque objets livrée avec le livre)
// est libre, vous pouvez le redistribuer et/ou
// le modifier selon les termes de la
// Licence Publique Générale GNU publiée par la
// Free Software Foundation (version 2 ou bien toute autre version
// ultérieure choisie par vous).
// Ce programme est distribué car potentiellement utile,
// mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
// y compris les garanties de commercialisation ou
// d'adaptation dans un but spécifique. Reportez-vous à la
// Licence Publique Générale GNU pour plus de détails.
// Vous devez avoir reçu une copie de la Licence
// Publique Générale GNU en même temps que
// ce programme ; si ce n'est pas le cas, écrivez à la
// Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
// 02111-1307, États-Unis.

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package testmongodb;

import com.mongodb.AggregationOutput;
import com.mongodb.BasicDBObject;
import com.mongodb.DB;
import com.mongodb.DBCollection;
import com.mongodb.DBCursor;
import com.mongodb.DBObject;
import com.mongodb.Mongo;
import com.mongodb.MongoClient;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.net.UnknownHostException;
import java.util.List;
import java.util.Set;
import java.util.regex.Pattern;

/**
 *
 * @author raksmey
 */
public class TestMongodb {

    /**
     * @param args the command line arguments
     */
    
    //suppression de la base bibliotheque
    public static void main(String[] args) {

        try {
            MongoClient mongoClient = new MongoClient();
            mongoClient.dropDatabase("bibliotheque");
            
            System.out.println("--- liste de toutes les bases de données ---");
            List<String> liste_de_nom = mongoClient.getDatabaseNames();
            for (String s : liste_de_nom) {
                System.out.println(s);
            }
        } catch (Exception E) {
            System.out.println(E.getMessage());
        }


        // Insertion de la table auteur
        
        try {
            MongoClient mongoClient = new MongoClient();
            DB db = mongoClient.getDB("bibliotheque");

            DBCollection coll = db.getCollection("Auteur");

            // insertion
            BasicDBObject dbObject = new BasicDBObject();
            dbObject.put("Numero", "85478");
            dbObject.put("Nom", "Castafiore");
            dbObject.put("Prenom", "Emilie");
            dbObject.put("Domicile", "Paris");

            coll.insert(dbObject);

            dbObject = new BasicDBObject();
            dbObject.put("Numero", "3547");
            dbObject.put("Nom", "Chambord");
            dbObject.put("Prenom", "Emilie");
            dbObject.put("Domicile", "Nice");
            coll.insert(dbObject);

            dbObject = new BasicDBObject();
            dbObject.put("Numero", "542563");
            dbObject.put("Nom", "Dupont");
            dbObject.put("Prenom", "Pierre");
            dbObject.put("Domicile", "Avignon");
            coll.insert(dbObject);

            dbObject = new BasicDBObject();
            dbObject.put("Numero", "52136");
            dbObject.put("Nom", "Fabière");
            dbObject.put("Prenom", "Sylvie");
            dbObject.put("Domicile", "Bordeaux");
            coll.insert(dbObject);

            dbObject = new BasicDBObject();
            dbObject.put("Numero", "8547585");
            dbObject.put("Nom", "Momo");
            dbObject.put("Prenom", "Roland");
            dbObject.put("Domicile", "Toulouse");
            coll.insert(dbObject);

            dbObject = new BasicDBObject();
            dbObject.put("Numero", "78545");
            dbObject.put("Nom", "Tintin");
            dbObject.put("Prenom", "Thierry");
            dbObject.put("Domicile", "Clermont");
            coll.insert(dbObject);

            // --------------------------
            // Code pour inserer les autres auteurs
            // --------------------------


            // --- fin insertion --- //
            System.out.println("affichage element 1");

            DBObject myDoc = coll.findOne();
            System.out.println(myDoc);

            // Affichage 
            System.out.println("affichage de tous les elements");
            DBCursor cursor = coll.find();

            while (cursor.hasNext()) {
                System.out.println(cursor.next());
            }
        } 
        catch (Exception E) 
        {
            System.out.println(E.getMessage());
        }



        // Recherche d'un auteur particulier  
         try 
         {            
            MongoClient mongoClient = new MongoClient();
            DB db = mongoClient.getDB( "bibliotheque" );

            DBCollection coll = db.getCollection("Auteur");

            Pattern Nom_a_rechercher = Pattern.compile("Castafiore", Pattern.CASE_INSENSITIVE);
            BasicDBObject query = new BasicDBObject("Nom", Nom_a_rechercher);

            DBObject reponse = coll.findOne(query);
            System.out.println("Acces à la premiere information : ");
            System.out.println(reponse);

            System.out.println("Parcours des elements...."); 
            DBCursor cursor = coll.find(query);        

            while(cursor.hasNext()) 
            {
              System.out.println("element : ");
              System.out.println(cursor.next());
            }
        } 
        catch (Exception E) 
        {
            System.out.println(E.getMessage());
        }

         
        // Ajouter des livre
        try {
            MongoClient mongoClient = new MongoClient();
            DB db = mongoClient.getDB("bibliotheque");

            DBCollection coll_livre = db.getCollection("Livre");

            BasicDBObject dbObject_Livre = new BasicDBObject();
            dbObject_Livre.put("Numero", "10101");
            dbObject_Livre.put("Titre", "aaaaa");
            dbObject_Livre.put("Prix", 10);
            coll_livre.insert(dbObject_Livre);

            dbObject_Livre = new BasicDBObject();
            dbObject_Livre.put("Numero", "11111");
            dbObject_Livre.put("Titre", "ee");
            dbObject_Livre.put("Prix", 54);
            coll_livre.insert(dbObject_Livre);

            dbObject_Livre = new BasicDBObject();
            dbObject_Livre.put("Numero", "80808");
            dbObject_Livre.put("Titre", "cccc");
            dbObject_Livre.put("Prix", 45);
            coll_livre.insert(dbObject_Livre);

            dbObject_Livre = new BasicDBObject();
            dbObject_Livre.put("Numero", "90909");
            dbObject_Livre.put("Titre", "ddddd");
            dbObject_Livre.put("Prix", 35);
            coll_livre.insert(dbObject_Livre);

            dbObject_Livre = new BasicDBObject();
            dbObject_Livre.put("Numero", "202022");
            dbObject_Livre.put("Titre", "bb");
            dbObject_Livre.put("prix", 25);
            coll_livre.insert(dbObject_Livre);

            System.out.println("affichage de tous les livres");
            DBCursor cursor = coll_livre.find();

            while (cursor.hasNext()) {
                System.out.println(cursor.next());
            }
        } catch (Exception E) {
            System.out.println(E.getMessage());
        }

    }
}
